overwrite dynarec related code with upstream version
[pcsx_rearmed.git] / configure
CommitLineData
4132e8ca 1#!/bin/sh
2# some elements originated from qemu configure
3set -e
4
5TMPC="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.c"
6TMPO="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}.o"
07c13dfd 7TMPB="/tmp/pcsx-conf-${RANDOM}-$$-${RANDOM}"
8trap "rm -f $TMPC $TMPO $TMPB" EXIT INT QUIT TERM
4132e8ca 9rm -f config.log
10
11compile_object()
12{
07c13dfd 13 c="$CC $CFLAGS -c $TMPC -o $TMPO $@"
14 echo $c >> config.log
15 $c >> config.log 2>&1
16}
17
18compile_binary()
19{
20 c="$CC $CFLAGS $TMPC -o $TMPB $LDFLAGS $MAIN_LDLIBS $@"
4132e8ca 21 echo $c >> config.log
22 $c >> config.log 2>&1
23}
24
25check_define()
26{
cc376814 27 $CC -E -dD $CFLAGS include/arm_features.h | grep -q "$1" || return 1
28 return 0
29}
30
31check_define_val()
32{
33 $CC -E -dD $CFLAGS include/arm_features.h | grep "$1" | awk '{print $3}'
4132e8ca 34 return 0
35}
36
37# setting options to "yes" or "no" will make that choice default,
38# "" means "autodetect".
39
38c2028e 40platform_list="generic pandora maemo caanoo libretro"
4132e8ca 41platform="generic"
61bc6d40 42builtin_gpu_list="peops unai neon"
43builtin_gpu=""
b68bf5c2 44sound_driver_list="oss alsa pulseaudio sdl libretro"
07c13dfd 45sound_drivers=""
dd4d5a35 46plugins="plugins/spunull/spunull.so \
47plugins/dfxvideo/gpu_peops.so plugins/gpu_unai/gpu_unai.so"
4132e8ca 48drc_cache_base="no"
00a212aa 49have_armv5=""
4132e8ca 50have_armv6=""
51have_armv7=""
52have_arm_neon=""
53have_tslib=""
5b9aa749 54have_gles=""
5514a050 55have_c64x_dsp=""
4132e8ca 56enable_dynarec="yes"
f89fa2d9 57need_sdl="no"
955f9af0 58need_xlib="no"
cc56203b 59need_libpicofe="yes"
60need_warm="no"
5b9aa749 61CFLAGS_GLES=""
62LDLIBS_GLES=""
4132e8ca 63# these are for known platforms
64optimize_cortexa8="no"
65optimize_arm926ej="no"
66
67# hardcoded stuff
68CC="${CC-${CROSS_COMPILE}gcc}"
ac6575cd 69CXX="${CXX-${CROSS_COMPILE}g++}"
4132e8ca 70AS="${AS-${CROSS_COMPILE}as}"
71AR="${AS-${CROSS_COMPILE}ar}"
9aff1963 72MAIN_LDLIBS="$LDLIBS -ldl -lm -lpthread"
4132e8ca 73config_mak="config.mak"
74
07c13dfd 75fail()
76{
77 echo "$@"
630b122b 78 if test -n "$DUMP_CONFIG_LOG"; then cat config.log; fi
07c13dfd 79 exit 1
80}
81
4132e8ca 82# call during arg parsing, so that cmd line can override platform defaults
83set_platform()
84{
85 platform=$1
86 case "$platform" in
87 generic)
88 ;;
89 pandora)
07c13dfd 90 sound_drivers="oss alsa"
4132e8ca 91 drc_cache_base="yes"
92 optimize_cortexa8="yes"
93 have_arm_neon="yes"
955f9af0 94 need_xlib="yes"
4132e8ca 95 ;;
96 maemo)
4132e8ca 97 drc_cache_base="yes"
98 optimize_cortexa8="yes"
99 have_arm_neon="yes"
100 ;;
101 caanoo)
07c13dfd 102 sound_drivers="oss"
4132e8ca 103 drc_cache_base="yes"
104 optimize_arm926ej="yes"
cc56203b 105 need_warm="yes"
4132e8ca 106 ;;
38c2028e 107 libretro)
07c13dfd 108 sound_drivers="libretro"
cc56203b 109 need_libpicofe="no"
38c2028e 110 ;;
4132e8ca 111 *)
07c13dfd 112 fail "unsupported platform: $platform"
4132e8ca 113 ;;
114 esac
115}
116
117for opt do
118 optarg=`expr "x$opt" : 'x[^=]*=\(.*\)'` || true
119 case "$opt" in
120 --help|-h) show_help="yes"
121 ;;
122 --platform=*) set_platform "$optarg"
123 ;;
61bc6d40 124 --gpu=*) builtin_gpu="$optarg"
125 ;;
07c13dfd 126 --sound-drivers=*) sound_drivers="$optarg"
4132e8ca 127 ;;
128 --enable-neon) have_arm_neon="yes"
129 ;;
130 --disable-neon) have_arm_neon="no"
131 ;;
132 --disable-dynarec) enable_dynarec="no"
133 ;;
134 *) echo "ERROR: unknown option $opt"; show_help="yes"
135 ;;
136 esac
137done
138
139if [ "$show_help" = "yes" ]; then
140 echo "options:"
141 echo " --help print this message"
142 echo " --platform=NAME target platform [$platform]"
143 echo " available: $platform_list"
61bc6d40 144 echo " --gpu=NAME builtin gpu plugin [guessed]"
145 echo " available: $builtin_gpu_list"
07c13dfd 146 echo " --sound-drivers=LIST sound output drivers [guessed]"
4132e8ca 147 echo " available: $sound_driver_list"
148 echo " --enable-neon"
149 echo " --disable-neon enable/disable ARM NEON optimizations [guessed]"
150 echo " --disable-dynarec disable dynamic recompiler"
151 echo " (dynarec is only available and enabled on ARM)"
152 echo "influential environment variables:"
ac6575cd 153 echo " CROSS_COMPILE CC CXX AS AR CFLAGS ASFLAGS LDFLAGS LDLIBS"
4132e8ca 154 exit 1
155fi
156
07c13dfd 157# validate selections
61bc6d40 158if [ "x$builtin_gpu" != "x" ]; then
07c13dfd 159 if ! echo $builtin_gpu_list | grep -q "\<$builtin_gpu\>"; then
160 fail "unsupported builtin gpu plugin: $builtin_gpu"
161 fi
61bc6d40 162fi
163
07c13dfd 164if [ "x$sound_drivers" != "x" ]; then
165 for d in $sound_drivers; do
166 if ! echo $sound_driver_list | grep -q "\<$d\>"; then
167 fail "unsupported sound driver: $sound_driver"
168 fi
169 done
170fi
4132e8ca 171
cc56203b 172if [ "$need_libpicofe" = "yes" ]; then
173 if ! test -f "frontend/libpicofe/README"; then
174 fail "libpicofe is missing, please run 'git submodule init && git submodule update'"
175 fi
176fi
177
178if [ "$need_warm" = "yes" ]; then
179 if ! test -f "frontend/warm/README"; then
180 fail "wARM is missing, please run 'git submodule init && git submodule update'"
181 fi
182fi
183
00a212aa 184# basic compiler test
185cat > $TMPC <<EOF
186#include <zlib.h>
187int main(void) { return 0; }
188EOF
189if ! compile_binary; then
0dc1b4a9 190 fail "compiler test failed, please check config.log"
00a212aa 191fi
192
4132e8ca 193if [ -z "$ARCH" ]; then
0dc1b4a9 194 ARCH=`$CC -dumpmachine | awk -F '-' '{print $1}'`
4132e8ca 195fi
196
0dc1b4a9 197case "$ARCH" in
198arm*)
199 # ARM stuff
200 ARCH="arm"
201
4132e8ca 202 if [ "$optimize_cortexa8" = "yes" ]; then
4132e8ca 203 CFLAGS="$CFLAGS -mcpu=cortex-a8 -mtune=cortex-a8"
204 ASFLAGS="$ASFLAGS -mcpu=cortex-a8"
205 fi
206 if [ "$optimize_arm926ej" = "yes" ]; then
207 CFLAGS="$CFLAGS -mcpu=arm926ej-s -mtune=arm926ej-s"
208 ASFLAGS="$ASFLAGS -mcpu=arm926ej-s -mfloat-abi=softfp"
209 fi
210
211 if [ "x$have_arm_neon" = "x" ]; then
212 # detect NEON from user-supplied cflags to enable asm code
213 have_arm_neon=`check_define __ARM_NEON__ && echo yes` || true
214 fi
4132e8ca 215 if [ "x$have_armv7" = "x" ]; then
00a212aa 216 if check_define HAVE_ARMV7; then
4132e8ca 217 have_armv7="yes"
00a212aa 218 have_armv6="yes"
219 have_armv5="yes"
4132e8ca 220 fi
221 fi
00a212aa 222 if [ "x$have_armv6" = "x" ]; then
223 if check_define HAVE_ARMV6; then
224 have_armv6="yes"
225 have_armv5="yes"
226 fi
227 fi
228 if [ "x$have_armv5" = "x" ]; then
229 have_armv5=`check_define HAVE_ARMV5 && echo yes` || true
230 fi
4132e8ca 231
61bc6d40 232 if [ "x$builtin_gpu" = "x" ]; then
233 if [ "$have_arm_neon" = "yes" ]; then
234 builtin_gpu="neon"
235 elif [ "$have_armv7" != "yes" ]; then
236 # pre-ARMv7 hardware is usually not fast enough for peops
237 builtin_gpu="unai"
238 else
239 builtin_gpu="peops"
240 fi
241 fi
242
e795af9e 243 # automatically set mfpu and mfloat-abi if they are not set
4132e8ca 244 if [ "$have_arm_neon" = "yes" ]; then
40cf6975 245 fpu="neon"
4132e8ca 246 elif [ "$have_armv6" = "yes" ]; then
40cf6975 247 fpu="vfp"
4132e8ca 248 fi
40cf6975 249 if [ "x$fpu" != "x" ]; then
250 echo "$CFLAGS" | grep -q -- '-mfpu=' || CFLAGS="$CFLAGS -mfpu=$fpu"
251 echo "$ASFLAGS" | grep -q -- '-mfpu=' || ASFLAGS="$ASFLAGS -mfpu=$fpu"
252 floatabi_set_by_gcc=`$CC -v 2>&1 | grep -q -- --with-float= && echo yes` || true
253 if [ "$floatabi_set_by_gcc" != "yes" ]; then
254 echo "$CFLAGS" | grep -q -- '-mfloat-abi=' || CFLAGS="$CFLAGS -mfloat-abi=softfp"
255 echo "$ASFLAGS" | grep -q -- '-mfloat-abi=' || ASFLAGS="$ASFLAGS -mfloat-abi=softfp"
256 fi
4132e8ca 257 fi
258
9f704290 259 # must disable thumb as recompiler can't handle it
96751f36 260 if check_define __thumb__; then
9f704290 261 CFLAGS="$CFLAGS -marm"
96751f36 262 fi
00a212aa 263
264 # warn about common mistakes
265 if [ "$have_armv5" != "yes" ]; then
266 if ! echo "$CFLAGS" | grep -q -- '-mcpu=\|-march='; then
267 echo "Warning: compiling for ARMv4, is that really what you want?"
268 echo "You probably should specify -mcpu= or -march= like this:"
269 echo " CFLAGS=-march=armv6 ./configure ..."
270 fi
271 fi
272 if [ "$have_arm_neon" = "yes" -a "$have_armv7" != "yes" ]; then
273 echo "Warning: compiling for NEON, but not ARMv7?"
274 echo "You probably want to specify -mcpu= or -march= like this:"
275 echo " CFLAGS=-march=armv7-a ./configure ..."
276 fi
0dc1b4a9 277 ;;
630b122b 278aarch64)
279 ;;
0dc1b4a9 280*)
630b122b 281 # dynarec only available on ARM
282 enable_dynarec="no"
0dc1b4a9 283 ;;
284esac
4132e8ca 285
61bc6d40 286if [ "x$builtin_gpu" = "x" ]; then
287 builtin_gpu="peops"
288fi
289
4132e8ca 290# supposedly we can avoid -fPIC on armv5 for slightly better performace?
291if [ "$ARCH" != "arm" -o "$have_armv6" = "yes" ]; then
292 PLUGIN_CFLAGS="$PLUGIN_CFLAGS -fPIC"
293fi
294
38c2028e 295case "$platform" in
296generic)
f89fa2d9 297 need_sdl="yes"
38c2028e 298 ;;
299maemo)
7010034e 300 CFLAGS="$CFLAGS -DMAEMO -DMAEMO_CHANGES"
38c2028e 301 ;;
302libretro)
303 CFLAGS="$CFLAGS -fPIC"
22fa3f2b 304 MAIN_LDFLAGS="$MAIN_LDFLAGS -shared -Wl,--no-undefined"
38c2028e 305 ;;
306esac
4132e8ca 307
07c13dfd 308# header/library presence tests
309check_zlib()
310{
311 cat > $TMPC <<EOF
312 #include <zlib.h>
791f6e3e 313 int main(void) { uncompress(0, 0, 0, 0); }
07c13dfd 314EOF
315 compile_binary
316}
317
07c13dfd 318check_libpng()
319{
320 cat > $TMPC <<EOF
321 #include <png.h>
322 void main() { png_init_io(0, 0); }
323EOF
324 compile_binary
325}
326
327check_oss()
328{
329 cat > $TMPC <<EOF
330 #include <sys/soundcard.h>
331 #include <sys/ioctl.h>
332 void main() { int a=0; ioctl(0, SNDCTL_DSP_SETFMT, &a); }
333EOF
334 compile_binary
335}
336
337check_alsa()
338{
339 cat > $TMPC <<EOF
340 #include <alsa/asoundlib.h>
341 void main() { snd_pcm_open(0, 0, 0, 0); }
342EOF
343 compile_binary "$@"
344}
345
b68bf5c2 346check_pulseaudio()
347{
348 cat > $TMPC <<EOF
349 #include <pulse/pulseaudio.h>
350 void main() { pa_threaded_mainloop_new(); }
351EOF
352 compile_binary "$@"
353}
354
07c13dfd 355check_sdl()
356{
357 cat > $TMPC <<EOF
358 #include <SDL.h>
359 void main() { SDL_OpenAudio(0, 0); }
360EOF
361 compile_binary "$@"
362}
363
955f9af0 364check_xlib_headers()
365{
366 cat > $TMPC <<EOF
367 #include <X11/Xlib.h>
368 void *f() { return XOpenDisplay(0); }
369EOF
370 compile_object "$@"
371}
372
5514a050 373# see if we have c64_tools for TI C64x DSP
374check_c64_tools()
375{
376 cat > $TMPC <<EOF
377 #include <inc_libc64_mini.h>
378 int f() { return dsp_open(); }
379EOF
380 compile_object "$@"
381}
382
f89fa2d9 383MAIN_LDLIBS="$MAIN_LDLIBS -lz"
9f704290 384check_zlib || fail "please install zlib (libz-dev)"
f89fa2d9 385
f89fa2d9 386MAIN_LDLIBS="-lpng $MAIN_LDLIBS"
9f704290 387check_libpng || fail "please install libpng (libpng-dev)"
07c13dfd 388
389# find what audio support we can compile
390if [ "x$sound_drivers" = "x" ]; then
391 if check_oss; then sound_drivers="$sound_drivers oss"; fi
f89fa2d9 392 if check_alsa -lasound; then
393 sound_drivers="$sound_drivers alsa"
394 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
395 fi
b68bf5c2 396 if check_pulseaudio -lpulse; then
397 sound_drivers="$sound_drivers pulseaudio"
398 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
399 fi
9f704290 400 if [ "$need_sdl" = "yes" ] || check_sdl `sdl-config --cflags --libs`; then
f89fa2d9 401 sound_drivers="$sound_drivers sdl"
402 need_sdl="yes"
403 fi
404else
405 if echo $sound_drivers | grep -q "\<oss\>"; then
406 check_oss || fail "oss support is missing"
407 fi
408 if echo $sound_drivers | grep -q "\<alsa\>"; then
409 MAIN_LDLIBS="-lasound $MAIN_LDLIBS"
410 check_alsa || fail "please install libasound2-dev"
411 fi
b68bf5c2 412 if echo $sound_drivers | grep -q "\<pulseaudio\>"; then
413 MAIN_LDLIBS="-lpulse $MAIN_LDLIBS"
414 check_pulseaudio || fail "pulseaudio support is missing"
415 fi
07c13dfd 416fi
417
9f704290 418if [ "$need_sdl" = "yes" ]; then
419 which sdl-config > /dev/null || \
420 fail "sdl-config is missing; please install libsdl (libsdl1.2-dev)"
f89fa2d9 421 CFLAGS="$CFLAGS `sdl-config --cflags`"
422 MAIN_LDLIBS="`sdl-config --libs` $MAIN_LDLIBS"
9f704290 423 check_sdl || fail "please install libsdl (libsdl1.2-dev)"
07c13dfd 424fi
425
4132e8ca 426# check for tslib (only headers needed)
427if [ "x$have_tslib" = "x" ]; then
428 cat > $TMPC <<EOF
429 #include <tslib.h>
430 void test(struct ts_sample sample) {}
431EOF
432 if compile_object; then
433 have_tslib="yes"
434 else
435 have_tslib="no"
436 fi
437fi
438
5b9aa749 439# check for VideoCore stuff for Raspberry Pi
ad6150e0 440if [ -d /opt/vc/include -a -d /opt/vc/lib -a "$VIDEOCORE" != "no" ]; then
237d1f6f 441 CFLAGS_GLES="$CFLAGS_GLES -I/opt/vc/include -I/opt/vc/include/interface/vcos/pthreads -I/opt/vc/include/interface/vmcs_host/linux"
5b9aa749 442 LDLIBS_GLES="$LDLIBS_GLES -L/opt/vc/lib"
cbcadc5f 443 if [ -f /opt/vc/lib/libbcm_host.so ]; then
444 LDLIBS_GLES="$LDLIBS_GLES -lbcm_host"
445 fi
955f9af0 446 need_xlib="yes"
ad6150e0 447 VIDEOCORE="yes"
5b9aa749 448fi
449
dd4d5a35 450# check for GLES headers
451cat > $TMPC <<EOF
452#include <GLES/gl.h>
dd4d5a35 453#include <EGL/egl.h>
5b9aa749 454int main(void) {
455 return (int)eglGetDisplay( (EGLNativeDisplayType)0 );
dd4d5a35 456}
457EOF
ad6150e0
CG
458if [ "$VIDEOCORE" = "yes" ] && compile_binary $CFLAGS_GLES -lbrcmEGL -lbrcmGLESv2 $LDLIBS_GLES; then
459 have_gles="yes"
460 LDLIBS_GLES="-lbrcmEGL -lbrcmGLESv2 $LDLIBS_GLES"
461elif compile_binary $CFLAGS_GLES -lEGL -lGLES_CM $LDLIBS_GLES; then
5b9aa749 462 have_gles="yes"
463 LDLIBS_GLES="-lEGL -lGLES_CM $LDLIBS_GLES"
464elif compile_binary $CFLAGS_GLES -lEGL -lGLESv1_CM $LDLIBS_GLES; then
465 have_gles="yes"
466 LDLIBS_GLES="-lEGL -lGLESv1_CM $LDLIBS_GLES"
dd4d5a35 467fi
468
5514a050 469if check_c64_tools; then
470 have_c64x_dsp="yes"
471fi
472
5b9aa749 473if [ "$have_gles" = "yes" ]; then
474 plugins="$plugins plugins/gpu-gles/gpu_gles.so"
475fi
61bc6d40 476if [ "$have_arm_neon" = "yes" -a "$builtin_gpu" != "neon" ]; then
477 plugins="$plugins plugins/gpu_neon/gpu_neon.so"
478fi
479
955f9af0 480# check for xlib (only headers needed)
481if [ "x$need_xlib" = "xyes" ]; then
482 check_xlib_headers || fail "please install libx11-dev"
483fi
484
cc376814 485sizeof_long=`check_define_val __SIZEOF_LONG__`
486if [ "x$sizeof_long" = "x4" ]; then
487 CFLAGS="$CFLAGS -D_FILE_OFFSET_BITS=64"
488fi
489
9f704290 490cat > $TMPC <<EOF
491void test(void *f, void *d) { fread(d, 1, 1, f); }
492EOF
493if compile_object -Wno-unused-result; then
494 CFLAGS="$CFLAGS -Wno-unused-result"
495fi
496
dd4d5a35 497# short plugin list for display
498for p in $plugins; do
499 p1=`basename $p`
500 plugins_short="$p1 $plugins_short"
501done
502
4132e8ca 503# set things that failed to autodetect to "no"
504test "x$have_armv6" != "x" || have_armv6="no"
505test "x$have_armv7" != "x" || have_armv7="no"
506test "x$have_arm_neon" != "x" || have_arm_neon="no"
00a212aa 507test "x$have_gles" != "x" || have_gles="no"
5514a050 508test "x$have_c64x_dsp" != "x" || have_c64x_dsp="no"
4132e8ca 509
510echo "architecture $ARCH"
511echo "platform $platform"
61bc6d40 512echo "built-in GPU $builtin_gpu"
07c13dfd 513echo "sound drivers $sound_drivers"
dd4d5a35 514echo "plugins $plugins_short"
4132e8ca 515echo "C compiler $CC"
516echo "C compiler flags $CFLAGS"
07c13dfd 517echo "libraries $MAIN_LDLIBS"
22fa3f2b 518echo "linker flags $LDFLAGS$MAIN_LDFLAGS"
4132e8ca 519echo "enable dynarec $enable_dynarec"
5514a050 520if [ "$ARCH" = "arm" ]; then
521 echo "ARMv7 optimizations $have_armv7"
522 echo "enable ARM NEON $have_arm_neon"
523 echo "TI C64x DSP support $have_c64x_dsp"
524fi
4132e8ca 525echo "tslib support $have_tslib"
2c616080 526if [ "$platform" = "generic" ]; then
527 echo "OpenGL ES output $have_gles"
528fi
4132e8ca 529
530echo "# Automatically generated by configure" > $config_mak
531printf "# Configured with:" >> $config_mak
532printf " '%s'" "$0" "$@" >> $config_mak
533echo >> $config_mak
534
535echo "CC = $CC" >> $config_mak
ac6575cd 536echo "CXX = $CXX" >> $config_mak
4132e8ca 537echo "AS = $AS" >> $config_mak
538echo "CFLAGS += $CFLAGS" >> $config_mak
539echo "ASFLAGS += $ASFLAGS" >> $config_mak
540echo "LDFLAGS += $LDFLAGS" >> $config_mak
22fa3f2b 541echo "MAIN_LDFLAGS += $MAIN_LDFLAGS" >> $config_mak
07c13dfd 542echo "MAIN_LDLIBS += $MAIN_LDLIBS" >> $config_mak
4132e8ca 543echo "PLUGIN_CFLAGS += $PLUGIN_CFLAGS" >> $config_mak
544echo >> $config_mak
545
38c2028e 546if [ "$platform" = "libretro" ]; then
547 echo "TARGET = libretro.so" >> $config_mak
548fi
4132e8ca 549echo "ARCH = $ARCH" >> $config_mak
550echo "PLATFORM = $platform" >> $config_mak
61bc6d40 551echo "BUILTIN_GPU = $builtin_gpu" >> $config_mak
07c13dfd 552echo "SOUND_DRIVERS = $sound_drivers" >> $config_mak
630b122b 553echo "PLUGINS = $plugins" >> $config_mak
4132e8ca 554if [ "$have_arm_neon" = "yes" ]; then
555 echo "HAVE_NEON = 1" >> $config_mak
556fi
557if [ "$have_tslib" = "yes" ]; then
558 echo "HAVE_TSLIB = 1" >> $config_mak
559fi
5b9aa749 560if [ "$have_gles" = "yes" ]; then
561 echo "HAVE_GLES = 1" >> $config_mak
562 echo "CFLAGS_GLES = $CFLAGS_GLES" >> $config_mak
563 echo "LDLIBS_GLES = $LDLIBS_GLES" >> $config_mak
564fi
4132e8ca 565if [ "$enable_dynarec" = "yes" ]; then
566 echo "USE_DYNAREC = 1" >> $config_mak
567fi
568if [ "$drc_cache_base" = "yes" ]; then
630b122b 569 echo "BASE_ADDR_DYNAMIC = 1" >> $config_mak
4132e8ca 570fi
5514a050 571if [ "$have_c64x_dsp" = "yes" ]; then
572 echo "HAVE_C64_TOOLS = 1" >> $config_mak
573fi
4132e8ca 574
2e6189bc 575# use pandora's skin (for now)
576test -e skin || ln -s frontend/pandora/skin skin
577
4132e8ca 578# vim:shiftwidth=2:expandtab